jQuery(function() {
	jQuery('#jfsimportform #file').change(function() {
		jQuery("#jfsimportresult").html("");
	});
	
	var loadBackups = function() {
		jQuery.ajax({
			url: contextPath + "/rest/fieldsecurity/1.0/config/backups/list",
			success: function(data, textStatus, jqXHR) {
				var cnt = jQuery("#jfsbackupscontainer").empty();
				if (!data.backups.length) {
					return;
				}
				
				var oddRow = true;
				jQuery.each(data.backups, function(idx, val) {
					var rowCss = {overflow:"auto", width:"99%"};
					if (oddRow) {
						rowCss['background-color'] = "#EEEEEE";
					}
					oddRow = !oddRow;
					
					var row = jQuery("<div>").css(rowCss);
					var colCss = {"float":"left", width: "30%"};
					var dName = jQuery("<div>").text(val.name).css(colCss);
					
					colCss.width = "20%";
					var dCreated = jQuery("<div>").text(val.formattedDate).css(colCss);
					
					colCss.width = "15%";
					var aDownload = jQuery("<a>").text("Download").attr({
						href: contextPath + "/rest/fieldsecurity/1.0/config/backups/download/" + val.name
					});
					var dDownload = jQuery("<div>").append(aDownload).css(colCss);
					
					var aRestore = jQuery("<a>").text("Restore").attr({
						href:"#",
						onclick: "return false;"
					}).click(function() {
						if (!confirm("Are you sure you want to restore " + val.name + "?")) {
							return;
						}
						
						jQuery.ajax({
							url: contextPath + "/rest/fieldsecurity/1.0/config/backups/restore/" + val.name,
							success: function(data, textStatus, jqXHR) {
								jQuery("#jfsimportresult").html(
									"<p>Configuration restored successfully from " + val.name + "</p>" +
									"<p>Previous configuration saved as <i>" + data.backup_filename + "</i>.</p>");
								loadBackups();
							}
						});
					});
					var dRestore = jQuery("<div>").append(aRestore).css(colCss);
					
					var aDelete = jQuery("<a>").text("Delete").attr({
						href:"#",
						onclick: "return false;"
					}).click(function() {
						if (!confirm("Are you sure you want to delete " + val.name + "?")) {
							return;
						}
						
						jQuery.ajax({
							url: contextPath + "/rest/fieldsecurity/1.0/config/backups/delete/" + val.name,
							success: function(data, textStatus, jqXHR) {
								loadBackups();
							}
						});
					});
					var dDelete = jQuery("<div>").append(aDelete).css(colCss);
					
					row.append(dName).append(dCreated).append(dDownload).append(dRestore).append(dDelete);
					cnt.append(row);
				});
			}
			
		});
	};
	loadBackups();
	
	jQuery("#jfscreatebackup").click(function() {
		jQuery.ajax({
			url: contextPath + "/rest/fieldsecurity/1.0/config/backups/create",
			success: function(data, textStatus, jqXHR) {
				loadBackups();
			}
		});
	});
	jQuery("form#jfsimportform").ajaxForm({
		resetForm: true,
		clearForm: true,
		dataType: 'json',
		success: function(response, statusText, xhr, form) {
			jQuery("#jfsimportresult").html(
				"<p>Configuration imported successfully.</p>" +
				"<p>Previous configuration saved as <i>" + response.backup_filename + "</i>.</p>");
			loadBackups();
		}
	});
});